package com.plannaplan.abstracts;

import java.util.ArrayList;
import java.util.List;

import com.plannaplan.interfaces.EventCreator;

public abstract class EventWatcher {

    protected List<EventCreator> creators;

    public EventWatcher() {
        this.creators = new ArrayList<>();
    }

    public void attach(EventCreator creator) {
        this.creators.add(creator);
    }

    public void detach(EventCreator creator) {
        this.creators.remove(creator);
    }

    public void update() {
    }
}