package com.plannaplan.repositories;

import java.util.List;

import com.plannaplan.entities.Groups;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

@Repository
public interface GroupRepository extends JpaRepository<Groups, Long> {
    @Query(value = "SELECT * FROM groups WHERE time = :time AND room = :room AND capacity = :capacity ", nativeQuery = true)
    Groups find(@Param("time") int time, @Param("room") String room, @Param("capacity") int capacity);

    @Query(value = "SELECT * FROM groups WHERE course_id = :id", nativeQuery = true)
    List<Groups> getByCourse(@Param("id") Long id);

}